#ifndef _KBNOTE_H_
#define _KBNOTE_H_

#include "kbId.h"

/**
 * Objects of this class are notes. They do not need a (graphical) presentation of their own. They can be displayed
 * graphically within the presentation of the parts, they belong to. This is done in editors.
 * @short Note Class
 * @author Jan Wuerthner
 * @version 0.95
 */
class KbNote : public KbId
{
 private:
  int freq;
  int vel;
  int len;
  int pos;
  int enh;
  KbNote * next;

 public:
  KbNote( );
  KbNote(int f,int v ,int l,int p,int e);

  KbNote * gNext();
  void sNext(KbNote * n);

  int gFreq();
  int gVel();
  int gLen();
  int gPos();
  int gEnh();
  void sFreq(int f);
  void sVel(int v);
  void sLen(int l);
  void sPos(int p);
  void sEnh(int e);

};

#endif
