#ifndef _KBPART_C_
#define _KBPART_C_

#include "kbPart.h"
#include "ifFactory.h"
#include "kbMain.h"
#include "ifPart.h"
#include "kbTrack.h"
#include "kbNote.h"

KbPart::KbPart( KbTrack * kbTrack, int left, int right )
  : from(left), to(right), track(kbTrack), next(0), time1(kbTrack->gMain()->gMeter(0)), time2(kbTrack->gMain()->gMeter(1)), key(0), clef(0),
    first(0), cur(0), last(0)
{
  cout << "left: " << left << ", right: " << right << endl;
  // check for possible position:
  bool loop=true;
  KbPart * pp;
  KbPart * pp1=0;
  //while (loop) {
  //  for (pp=kbTrack->gPart(); pp!=0; pp = pp->gNext()) {
      //if (from>=pp->gFrom() && from<pp->gTo()) from=pp->gTo();
      //if (to>pp->gFrom() && to<=pp->gTo()) to=pp->gFrom(); // was: && to<=pp->gTo()
  //  }
  // if (to<=from) { to = from+4; } else { loop=false; }
  // }

  int wid = right-left; if (wid<1) wid=1;
  for (pp=kbTrack->gPart(); pp!=0 && pp->gTo()<from; pp = pp->gNext()) { pp1=pp; }
  
  if (pp==0) {
    if (pp1!=0) { pp1->sNext(this); } else { kbTrack->sPart(this); }
  } else {
    //    if (pp1==0) {
    //  sNext(pp);
    //  kbTrack->sPart(this);
    //  if (pp->gFrom()<4) to=pp->gFrom();
    //} else {
    if (from<pp->gFrom()) {
      if (pp1==0) { kbTrack->sPart(this); sNext(pp); if (pp->gFrom()-from<4) to=pp->gFrom(); }
      else { pp1->sNext(this); sNext(pp); if (pp->gFrom()-from<4) to=pp->gFrom(); }
    } else {
      if (pp->gNext()==0) { // pp is currently the right most part
	pp->sNext(this);
	from = pp->gTo();
	to   = from+wid;
      } else { // now, we're waiting for a gap between the parts
	for (; pp!=0 && pp->gNext()!=0 && pp->gTo()==pp->gNext()->gFrom(); pp = pp->gNext()) { pp1=pp; }
	if (pp==0) {
	  if (pp1!=0) { pp->sNext(this); } else { kbTrack->sPart(this); }
	} else {
	  if (pp->gNext()==0) { // pp is currently the right most part
	    pp->sNext(this);
	    from = pp->gTo();
	    to   = from+wid;
	  } else { // here we've got a gap
	    wid = pp->gNext()->gFrom()-pp->gTo();
	    if (wid>4) wid = 4;
	    if (pp1!=0) {
	      pp1->sNext(this);
	      sNext(pp);
	    } else {
	      sNext(pp->gNext());
	      pp->sNext(this);
	    }
	  }
	}
      }
    }
  }
  
  /*  pp1 = 0;
      for (pp=kbTrack->gPart(); pp!=0 && from>=pp->gTo(); pp = pp->gNext()) { pp1 = pp; }
      
      if (pp1==0) {
      sNext(kbTrack->gPart());
      kbTrack->sPart(this);
      } else {
      sNext(pp1->gNext());
      pp1->sNext(this);
      }
  */
  ifPart = kbTrack->gMain()->gFactory()->createPart(this);

}

KbPart::~KbPart() {
  KbNote * n;
  KbNote * n1;
  n = first;
  while (n!=0) {
    if (n->gNext()==0) { delete n; n = 0; }
    else { n1 = n; n = n->gNext(); delete n1; }
  }
  first = 0; cur = 0; last = 0;
  gInterface()->erase();
}

IfPart * KbPart::gInterface() { return ifPart; }

KbTrack * KbPart::gTrack() {
  return track;
}

KbPart * KbPart::gNext() {
  return next;
}

void KbPart::sNext(KbPart * n) {
  next = n;
}


int KbPart::gFrom() {
  return from;
}

void KbPart::sFrom(int n) {
  from = n;
}

int KbPart::gTo() {
  return to;
}

void KbPart::sTo(int n) {
  to = n;
}

int KbPart::gKey() {
  return key;
}

void KbPart::sKey(int n) {
  key = n;
}

int KbPart::gClef() {
  return clef;
}

void KbPart::sClef(int n) {
  clef = n;
}

int KbPart::gTime1() {
  return time1;
}

void KbPart::sTime1(int t) {
  time1 = t;
}

int KbPart::gTime2() {
  return time2;
}

void KbPart::sTime2(int t) {
  time2 = t;
}


int KbPart::gProgram() {
  return program;
}

void KbPart::sProgram(int p) {
  program = p;
}


KbNote * KbPart::gFirst() {
  return first;
}

KbNote * KbPart::gLast() {
  return last;
}

KbNote * KbPart::gCur() {
  return cur;
}

void KbPart::sFirst(KbNote * n) {
  first = n;
}

void KbPart::sCur(KbNote * n) {
  cur = n;
}

void KbPart::sLast(KbNote * n) {
  last = n;
}

void KbPart::split(int splitBar) {
  if (gFrom()<splitBar && splitBar<gTo()) {
    int oldTo = gTo();
    sTo(splitBar);
    int deltaTick = int((splitBar-gFrom())*1536.0*gTime1()/gTime2());
    int off = int(gFrom()*1536.0*gTime1()/gTime2());
    KbPart * newPart = gTrack()->addPart(splitBar,oldTo);
    int splitPos = splitBar*int(1536.0*gTime1()/gTime2());
    KbNote * n;
    KbNote * n1 = 0;
    for (n=gFirst();n!=0 && n->gPos()+off<splitPos;n=n->gNext()) { n1 = n; }
    if (n!=0) {    // either part has no notes, or they remain ALL in this part!
      if (n1==0) { // no notes remain in this part!
	newPart->sFirst(gFirst()); newPart->sCur(gCur()); newPart->sLast(gLast());
	sFirst(0); sCur(0); sLast(0);
      } 
      else {
	n1->sNext(0);
	newPart->sLast(gLast());
	sLast(n1);
	sCur(gFirst());
	newPart->sFirst(n);
      }
    }
    if (deltaTick>0) for (n=newPart->gFirst();n!=0;n=n->gNext()) n->sPos(n->gPos()-deltaTick);
  }
}

void KbPart::glue() {
  KbPart * pt = gNext();
  int shift = int((pt->gFrom()-gFrom())*1536.0*gTime1()/gTime2());
  for (KbNote * n=pt->gFirst();n!=0;n=n->gNext()) {
    n->sPos(n->gPos()+shift);
  }
  if (gLast()!=0)
    gLast()->sNext(pt->gFirst());
  else
    sFirst(pt->gFirst());
    
  sLast(pt->gLast());
  pt->sFirst(0); pt->sCur(0); pt->sLast(0);
  pt->deletePart();
  // cosmetics:
  int end = 0;
  if (gLast()!=0)
    end = gLast()->gPos();
  int ticksPM = int(1536.0*gTime1()/gTime2());
  sTo(gFrom() + 1 + int(end/ticksPM));
}

void KbPart::deletePart() {
  KbPart * pt = 0;
  for (pt=gTrack()->gPart();pt!=0&&pt->gNext()!=this; pt=pt->gNext()) {}
  if (pt!=0) {
    pt->sNext(gNext());
    delete this;
  } else {
    gTrack()->sPart(gNext());
    delete this;
  }
  
}


// *******************************************************************************
//
// Note Handling
// =============
//



void KbPart::appendNote(KbNote* n)
{
  if (last!=0)
    {
      last->sNext(n);
      last=n;
    } else {
      first=cur=last=n;
    }
}


void KbPart::addNote(KbNote* n)
{
  cur = first;
  KbNote* prev=cur;
  if (first != 0) {
    if (last->gPos() < n->gPos()) {
      last->sNext(n);
      last=n;
    } else {
      if (n->gPos() < first->gPos()) {
	n->sNext(first);
	first=n;
      } else {
	for (cur=first; cur->gPos() < n->gPos(); cur=cur->gNext()) prev=cur;
	if (cur->gPos()==n->gPos()) { // same position, put lower note before higher note:
	  for (;cur->gFreq() < n->gFreq() && cur->gNext()!=0 && cur->gNext()->gPos()==n->gPos(); cur=cur->gNext()) prev=cur;
	  if (cur->gFreq() < n->gFreq()) {
	    n->sNext(cur->gNext());
	    cur->sNext(n);
	    if (n->gNext()==0) last=n;
	  } else {
		if (prev!=cur) {
		  n->sNext(cur);
		  prev->sNext(n);
		} else {
		  first=n;
		  n->sNext(cur);
		  if (cur->gNext()==0) last=cur;
		}
	      }
	    } else {
	      if (prev!=cur) {
		n->sNext(cur);
		prev->sNext(n);
	      } else {
		first=n;
		n->sNext(cur);
		last=cur;
	      }
	    }
	  }
	}
    } else {
      first=n;
      cur=n;
      last=n;
    }
}


void KbPart::selectNote(KbNote* n)
{
  cur=n;
}

void KbPart::deleteNote(KbNote* n)
{
  KbNote* prev=first;
  for (cur=first; cur!=n; cur=cur->gNext())
    {prev=cur;}
  if (cur==first) { first=cur->gNext(); prev=first; } else { prev->sNext(cur->gNext()); }
  delete cur;
  cur=prev;
  if (cur!=0)
    if (cur->gNext()==0) last=cur;
  
}


void KbPart::quantize(int q, int l, int r) {
  KbNote * left; KbNote * right;
  int foo;
  if (r!=0) {
    for (left=first;left!=0 && left->gPos()<l;left=left->gNext()) {}
    for (right=left;right!=0 && right->gPos()<r;right=right->gNext()) {}
  } else { left = first; right = last; }
  if (right==0) right = last;

  for (cur=left;cur!=0 && cur != right->gNext();cur=cur->gNext()) {
    foo = cur->gLen(); if (foo%q!=0) cur->sLen(q*int(foo*1.0/q+0.5));
    if (cur->gLen()==0) cur->sLen(q);
    foo = cur->gPos(); if (foo%q!=0) cur->sPos(q*int(foo*1.0/q+0.5));
  }
}

void KbPart::quantizeLength(int q, int l, int r) {
  KbNote * left; KbNote * right;
  int foo;
  if (r!=0) {
    for (left=first;left!=0 && left->gPos()<l;left=left->gNext()) {}
    for (right=left;right!=0 && right->gPos()<r;right=right->gNext()) {}
  } else { left = first; right = last; }
  if (right==0) right = last;

  for (cur=left;cur!=0 && cur != right->gNext();cur=cur->gNext()) {
    foo = cur->gLen(); if (foo%q!=0) cur->sLen(q*int(foo*1.0/q+0.5));
    if (cur->gLen()==0) cur->sLen(q);
  }
}

void KbPart::fixedLength(int q, int l, int r) {
  KbNote * left; KbNote * right;
  if (r!=0) {
    for (left=first;left!=0 && left->gPos()<l;left=left->gNext()) {}
    for (right=left;right!=0 && right->gPos()<r;right=right->gNext()) {}
  } else { left = first; right = last; }
  if (right==0) right = last;

  for (cur=left;cur!=0 && cur != right->gNext();cur=cur->gNext()) cur->sLen(q);
}


void KbPart::erase(int l, int r) {
  KbNote * prevlnote = 0;
  KbNote * lnote = 0;
  KbNote * rnote = 0;
  KbNote * nn1;
  for (cur=first;cur!=0;cur=cur->gNext()) {
    if (cur->gPos()>=l && lnote==0) lnote = cur;
    if (cur->gPos()<=r) rnote = cur;
    if (lnote==0) prevlnote = cur;
  }
  if (prevlnote==0) first = rnote->gNext();
  else prevlnote->sNext(rnote->gNext());
  if (rnote->gNext()==0) last = prevlnote;
  for (KbNote * nn=lnote; nn!=rnote;) {
    nn1 = nn->gNext();
    delete nn;
    nn = nn1;
  }
  delete rnote;
  // cout << first << ", " << last << endl;
}

bool KbPart::right()
{
  if (cur!=0)
    {
      cur=cur->gNext();
      if (cur==0) { cur=first; return true; }
      else return false;
    }
}

bool KbPart::left()
{
  KbNote* cc;
  cc=cur;
  if (cur!=0)
    {
      if (cur==first)
	{
	  cur=last;
	  return true;
	} else {
	  for (cur=first; cur->gNext() != cc; cur=cur->gNext()) {}
	  return false;
	}
      
    }
}

#endif
