#ifndef _KBTRACK_C_
#define _KBTRACK_C_

#include "kbTrack.h"
#include "kbPart.h"
#include <iostream.h>
#include <string.h>

KbTrack::KbTrack( KbMain * kbMain, int i )
  : main(kbMain), part(0), next(0), program(0), channel(i), output(0), volume(0), delay(0)
{
  sName(" - ");
  for (int i=0;i<3;i++) toggle[i] = false;
  ifTrack = kbMain->gFactory()->createTrack(this);
}

KbTrack::~KbTrack() {
  KbPart * p;
  KbPart * p1;
  p = part;
  while (p!=0) {
    if (p->gNext()==0) { delete p; p = 0; }
    else { p1 = p; p = p->gNext(); delete p1; }
  }
  part = 0;
  gInterface()->erase();
}

KbTrack * KbTrack::gNext() {
  return next;
}

void KbTrack::sNext(KbTrack * tr) {
  next = tr;
}

KbMain * KbTrack::gMain() {
  return main;
}

int KbTrack::trackNum() {
  int n=0;
  KbTrack * tr = main->gTrack();
  while (tr!=0 && tr!=this) {
    n++;
    tr = tr->gNext();
  }
  return n;
}

IfTrack * KbTrack::gInterface() { return ifTrack; }

KbPart * KbTrack::gPart() { return part; }

void KbTrack::sPart(KbPart * p) { part = p; }

int KbTrack::gChannel() { return channel; }

void KbTrack::sChannel(int n) { channel = n; }

int KbTrack::gProgram() { return program; }

void KbTrack::sProgram(int n) { program = n; }

int KbTrack::gOutput() { return output; }

void KbTrack::sOutput(int n) { output = n; main->closeDev(); }

int KbTrack::gVolume() { return volume; }

void KbTrack::sVolume(int n) { volume = n; }

int KbTrack::gDelay() { return delay; }

void KbTrack::sDelay(int n) { delay = n; }

bool KbTrack::gToggle(int i) { return toggle[i]; }

void KbTrack::sToggle(int i, bool n) { toggle[i] = n; }

KbPart * KbTrack::addPart(int left, int right) {
  KbPart * p = new KbPart(this,left,right);
  return p;
}

char * KbTrack::gName() { return name; }

void KbTrack::sName(char * n) { sprintf(name,"%s\0",n); }



#endif
