#ifndef _QTFACTORY_C_
#define _QTFACTORY_C_

#include "qtFactory.h"
#include "qtMain.h"
#include "qtTrack.h"
#include "qtPart.h"
#include "qtPrefs.h"
#include "qtScore.h"
#include "qtPiano.h"
#include "qtDrum.h"

#include "kbMain.h"

#include <iostream.h>

QtFactory::QtFactory() {}

IfMain * QtFactory::createMain(KbMain * kbmain, int argc, char ** argv) {
  KApplication* kooBase = new KApplication( argc, argv, "kooBase");
  QtMain * widget = new QtMain( "kooBase", kooBase, kbmain, argc, argv );
  kooBase->setMainWidget( widget );
  return widget;
}

IfTrack * QtFactory::createTrack(KbTrack * kbtrack) {
   QtTrack * qtr = new QtTrack(kbtrack);
   qtr->show();
   return qtr;
}

IfPart * QtFactory::createPart(KbPart * kbpart) {
  QtPart * qpt = new QtPart(kbpart);
  qpt->show();
  return qpt;
}

IfPrefs * QtFactory::createPrefs() {
  return new QtPrefs(0,"");
}

IfEditor * QtFactory::createScoreEditor(KbPart * kbpart) {
  return new QtScore(kbpart);
}

IfEditor * QtFactory::createPianoEditor(KbPart * kbpart) {
  return new QtPiano(kbpart);
}

IfEditor * QtFactory::createDrumEditor(KbPart * kbpart) {
  return new QtDrum(kbpart);
}


#endif
