#ifndef _QTSCORE_C_
#define _QTSCORE_C_

#include "qtScore.h"
#include "qtKeyChooser.h"
#include "kbPart.h"
#include "kbNote.h"
#include "kbTrack.h"

#include <math.h>
#include <iostream.h>

#define YTOP 108

enum { ID_AUTHOR, ID_OPTIONS_STN, ID_OPTIONS_SIN };

extern const char * gmNames[];

int sharpTab[] = { 0, 9, -3, 6, 15, 3, 12 }; 
int flatTab[] = { 12, 3, 15, 6, 18, 9, 0 };

int signShift[] = { 0, 6, 0, 0, 0, 6, 6, 12, 0, -6,9,3,-3,0 };

int invFreq[] = { 58, 58, 57, 57, 56, 55, 55, 54, 54, 53, 53, 52, 51, 51, 50, 50, 49, 48, 48, 47, 47, 46, 46, 45, 44, 44, 43, 43, 42, 41, 41, 40, 40, 39, 39, 38, 37, 37, 36, 36, 35, 34, 34, 33, 33, 32, 32, 31, 30, 30, 29, 29, 28, 27, 27, 26, 26, 25, 25, 24, 23, 23, 22, 22, 21, 20, 20, 19, 19, 18, 18, 17, 16, 16, 15, 15, 14, 13, 13, 12, 12, 11, 11, 10, 9, 9, 8, 8, 7, 6, 6, 5, 5, 4, 4, 3, 2, 2, 1 ,1, 0 };
int sign[] = {  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1 , 0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0 , 1,  0,  1,  0,  0,  1,  0,  1,  0,  0,  1,  0,  1,  0,  1,  0, 0, 1, 0 ,1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1 ,0, 1, 0, 0, 1, 0, 1, 0, 1, 0};



int enhF[5][12] = {
  { -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -2, -1 },
  {  0, -1,  0, -1, -1,  0, -1,  0, -1,  0, -1, -1 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },
  {  1,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0 },
  {  1,  1,  1,  0,  1,  1,  1,  1,  0,  1,  0,  1 }
};

int enhS[5][12] = {
  { -2, -1, -2, -2, -1, -2, -1, -2, -1, -2, -2, -1 },
  {  0, -1,  0, -1, -1,  0, -1,  0, -1,  0, -1, -1 },
  {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },
  {  1,  1,  0,  1,  0,  1,  1,  0,  1,  0,  1,  0 },
  {  1,  2,  2,  1,  2,  1,  2,  2,  1,  2,  1,  2 }
};

int yClef[] = { 0,-12,7,14,-7,-19,-26,-10,-14,-2,-4,-6,-8 };


int noteTab[] = { 'e', 'd', 'c', 'h', 'a', 'g', 'f', 'e', 'd', 'c', 'h', 'a', 'g', 'f', 'e', 'd', 'c', 'h', 'a', 'g', 'f', 'e', 'd', 'c', 'h', 'a', 'g', 'f', 'e', 'd', 'c', 'h', 'a', 'g', 'f', 'e', 'd', 'c' };
int freqTab[] = {100, 98, 96, 95, 93, 91, 89, 88, 86, 84, 83, 81, 79, 77, 76, 74, 72, 71, 69, 67, 65, 64, 62, 60, 59, 57, 55, 53, 52, 50, 48, 47, 45, 43, 41, 40, 38, 36, 35, 33, 31, 29, 28, 26, 24};


int allSigns[15][7] = {
 {-1, -1, -1, -1, -1, -1, -1 },
 {-1, -1, -1, -1, -1, -1,  0 },
 {-1, -1,  0, -1, -1, -1,  0 },
 {-1, -1,  0, -1, -1,  0,  0 },
 {-1,  0,  0, -1, -1,  0,  0 },
 {-1,  0,  0, -1,  0,  0,  0 },
 {0,   0,  0, -1,  0,  0,  0 },
 {0, 0, 0, 0, 0, 0, 0 },
 {0, 0, 0, 0, 0, 0, 1 },
 {0, 0, 1, 0, 0, 0, 1 },
 {0, 0, 1, 0, 0, 1, 1 },
 {0, 1, 1, 0, 0, 1, 1 },
 {0, 1, 1, 0, 1, 1, 1 },
 {1, 1, 1, 0, 1, 1, 1 },
 {1, 1, 1, 1, 1, 1, 1 }
};



// ******************************************************************
//
// Constructor
// ===========
//


QtScore::QtScore(KbPart * kbpart, bool all)
  : QtEditor("Score",kbpart,"Jan Wrthner", all),
    showIN(TRUE), showTN(FALSE), maxNnFlags(4), akkordmin(80), akkordmax(0), akkordmaxOld(0), akkordlen(0)
{
  QtEditor::init();
  if (parts==1) partList[0]=part;

  setBackgroundMode( PaletteLight );

  KIconLoader * loader = kapp->getIconLoader();
  
    QBitmap maske;
  QPixmap cursorPM = loader->loadIcon( "note0.xbm" ); QBitmap cursorBM; cursorBM = cursorPM;
  // cursor = new QCursor( cursorBM, cursorBM,7,7 );

  imgNote[0] = loader->loadIcon( "note0.xbm" ); maske = imgNote[0]; imgNote[0].setMask( maske );
  imgNote[1] = loader->loadIcon( "note1.xbm" ); maske = imgNote[1]; imgNote[1].setMask( maske );

  imgSign[0] = loader->loadIcon( "sgnFlat2.xbm" ); maske = imgSign[0]; imgSign[0].setMask( maske );
  imgSign[1] = loader->loadIcon( "sgnFlat.xbm" ); maske = imgSign[1]; imgSign[1].setMask( maske );
  imgSign[2] = loader->loadIcon( "note1.xbm" );
  imgSign[3] = loader->loadIcon( "sgnSharp.xbm" );  maske = imgSign[3]; imgSign[3].setMask( maske );
  imgSign[4] = loader->loadIcon( "sgnSharp2.xbm" );  maske = imgSign[4]; imgSign[4].setMask( maske );
  imgSign[5] = loader->loadIcon( "sgnNat.xbm" );  maske = imgSign[5]; imgSign[5].setMask( maske );

  imgClef[0] = loader->loadIcon( "key0.xbm" ); maske = imgClef[0]; imgClef[0].setMask( maske );
  imgClef[1] = loader->loadIcon( "key1.xbm" ); maske = imgClef[1]; imgClef[1].setMask( maske );
  imgClef[2] = loader->loadIcon( "key2.xbm" ); maske = imgClef[2]; imgClef[2].setMask( maske );
  imgClef[3] = loader->loadIcon( "key3.xbm" ); maske = imgClef[3]; imgClef[3].setMask( maske );
  imgClef[4] = loader->loadIcon( "key4.xbm" ); maske = imgClef[4]; imgClef[4].setMask( maske );
  imgClef[5] = loader->loadIcon( "key5.xbm" ); maske = imgClef[5]; imgClef[5].setMask( maske );
  imgClef[6] = loader->loadIcon( "key6.xbm" ); maske = imgClef[6]; imgClef[6].setMask( maske );
  imgClef[7] = loader->loadIcon( "key7.xbm" ); maske = imgClef[7]; imgClef[7].setMask( maske );
  imgClef[8] = loader->loadIcon( "key8.xbm" ); maske = imgClef[8]; imgClef[8].setMask( maske );
  imgClef[9] = loader->loadIcon( "key9.xbm" ); maske = imgClef[9]; imgClef[9].setMask( maske );
  imgClef[10] = loader->loadIcon( "key10.xbm" ); maske = imgClef[10]; imgClef[10].setMask( maske );
  imgClef[11] = loader->loadIcon( "key11.xbm" ); maske = imgClef[11]; imgClef[11].setMask( maske );
  imgClef[12] = loader->loadIcon( "key12.xbm" ); maske = imgClef[12]; imgClef[12].setMask( maske );
  imgClef[13] = loader->loadIcon( "key13.xbm" ); maske = imgClef[13]; imgClef[13].setMask( maske );
 
  imgFlat  = loader->loadIcon( "sgnFlat.xbm" );  maske = imgFlat; imgFlat.setMask( maske );
  imgSharp = loader->loadIcon( "sgnSharp.xbm" ); maske = imgSharp; imgSharp.setMask( maske );
  
  imgFlag  = loader->loadIcon( "flag.xbm" ); QBitmap BMflag; BMflag = imgFlag; imgFlag.setMask( BMflag );
  imgFlag1 = loader->loadIcon( "flagI.xbm" ); QBitmap BMflag1; BMflag1 = imgFlag1; imgFlag1.setMask( BMflag1 );

  arrBreak[9] = loader->loadIcon( "b1.xbm" ); maske = arrBreak[9]; arrBreak[9].setMask( maske );
  arrBreak[8] = loader->loadIcon( "b2.xbm" ); maske = arrBreak[8]; arrBreak[8].setMask( maske );
  arrBreak[7] = loader->loadIcon( "b4.xbm" ); maske = arrBreak[7]; arrBreak[7].setMask( maske );
  arrBreak[6] = loader->loadIcon( "b8.xbm" ); maske = arrBreak[6]; arrBreak[6].setMask( maske );
  arrBreak[5] = loader->loadIcon( "b16.xbm" ); maske = arrBreak[5]; arrBreak[5].setMask( maske );
  arrBreak[4] = loader->loadIcon( "b32.xbm" ); maske = arrBreak[4]; arrBreak[4].setMask( maske );


  buttonbar = new Buttonbar(this);
  // buttonbar->setFrameStyle( QFrame::Panel | QFrame::Raised );
  // buttonbar->setGeometry(0,78,640,22);
  addToolBar(buttonbar);
  buttonbar->show();
}

void QtScore::resizeEvent( QResizeEvent * re ) {
  QtEditor::resizeEvent(re);
  setFixedHeight(parts*100+YTOP+12);
}

void QtScore::addOptions() {
  options->insertItem( klocale->translate("Show Tracknames"), ID_OPTIONS_STN);
  options->insertItem( klocale->translate("Show Instrumentnames"), ID_OPTIONS_SIN);
  options->setCheckable(true);
  options->setItemChecked(ID_OPTIONS_SIN,TRUE);
}

void QtScore::settings() {
    QtChooser * ch = new QtChooser(part,this);
    ch->show();
}

void QtScore::optionsMenu(int n) {
  QtEditor::optionsMenu(n);
  switch(n) {
  case ID_OPTIONS_STN:
    if (showTN==TRUE) showTN=FALSE;
    else showTN=TRUE;
    options->setItemChecked(ID_OPTIONS_STN,showTN);
    // scanvas->showTN=showTN;
    // scanvas->repaint( FALSE );
    break;
  case ID_OPTIONS_SIN:
    if (showIN==TRUE) showIN=FALSE;
    else showIN=TRUE;
    options->setItemChecked(ID_OPTIONS_SIN,showIN);
    // scanvas->showIN=showIN;
    // scanvas->repaint( FALSE );
    break;
  }
}

int QtScore::gEnhValue() {
  return enhValue;
}

void QtScore::sEnhValue(int e) {
  enhValue = e;
}


// *****************************************************************************
//
// PAINT EVENT
// ===========
//

void QtScore::paintEvent( QPaintEvent * pe ) {
  scorelength = width()-20;
  
  QPixmap pix( width(), height() );
  pix.fill( this, 10,10 );
  QPainter score;
  score.begin( &pix );

  for (N=0;N<parts;N++) {
    
    // if (parts>1)
    part = partList[N];
    bool drawme=false;
    
    while (drawme==FALSE) {
      deltaOff[N] = (part->gFrom()-leftBar)*1536*part->gTime1()/part->gTime2();
      
      scrKey = part->gKey();
      clef = part->gClef();
      time1 = part->gTime1();
      time2 = part->gTime2();
      
      xLeft  = xmOffset*1536*time1/time2;
      xRight = xLeft+1536*time1/time2*barnum;
    
      if (allParts==false) drawme = TRUE; // if single part view, don't care about following parts !!
      else {
	if (part->gLast()!=0 && part->gLast()->gPos()+deltaOff[N]>=xLeft) drawme = TRUE;
	else {
	  if (part->gNext()!=0) part = part->gNext(); // DOIT: check
	  else drawme = TRUE;
	}
      }
    }

    ticksPerBar = int(1536.0*time1/time2);

    yoffset = 100*N + YTOP;
    nKey     = abs(scrKey);
    xoffset  = 60+6*abs(scrKey);
    xofftime = xoffset-10;
    barlen   = (scorelength-xoffset)/barnum;

    sprintf(t1, "%d", time1);
    sprintf(t2, "%d", time2);
    sprintf(t3, "%d", leftBar+xmOffset+1);
    
    for (int i=0;i<5;i++) {
      y = 40+i*6+yoffset;
      score.drawLine(QPoint(10,y),QPoint(scorelength+2,y));
    }
    score.drawLine(QPoint(10,yoffset+40),QPoint(10,yoffset+65));
    score.drawLine(QPoint(scorelength+2,yoffset+40),QPoint(scorelength+2,yoffset+65));
    score.drawPixmap(26-12,40-8+yoffset,imgClef[clef]); // draw Clef
    
    yytext = 0;
    if (showTN==TRUE) { score.drawText(10,14+yoffset-5,part->gTrack()->gName()); yytext = 10; }
    if (showIN==TRUE) {
      if (part->gTrack()->gProgram()==128) // track inst = "individual", i.e. delegated to parts
	score.drawText(10,14+yoffset+yytext-5,gmNames[part->gProgram()]);
      else 
	score.drawText(10,14+yoffset+yytext-5,gmNames[part->gTrack()->gProgram()]);
    }
    
    score.setFont(QFont("Helvetica",12,QFont::Normal,TRUE));
    score.drawText(xoffset,yoffset+36,t3); // draw bar
    score.setFont(QFont("Helvetica",12,QFont::Bold));
    score.drawText(xofftime,yoffset+51,t1); yytext = 10; // draw measurement
    score.drawText(xofftime,yoffset+63,t2); yytext = 10;
    score.setFont(QFont("Helvetica",12));
    
    for (int i=0; i<nKey; i++) {
      if (scrKey>0) { score.drawPixmap(45+i*6-8,yoffset+40+sharpTab[i]+signShift[clef]-12,imgSharp); // draw sharps
      } else { score.drawPixmap(45+i*6-8,yoffset+40+flatTab[i]+signShift[clef]-2-9,imgFlat);         // draw flats
      }
    }
    for (int i=1; i<barnum; i++) { score.drawLine(QPoint(xoffset+i*barlen-2, yoffset+40), QPoint(xoffset+i*barlen-2, yoffset+65)); }
    

    // draw notes:
    
    // xLeft & xRight def at top of paintEvent
    freePos = draw(xLeft,xRight,&score);
    drawFlags(&score);
    xoffset = 60+6*abs(scrKey);
    
    int n=0; // DOIT(old)!!
    
    barlen = int(1.0*(scorelength-xoffset)/barnum);
    ticksPerBar = int(1536.0*time1/time2);
    // cout << "ticksPB: " << ticksPerBar << endl;
    oldFreePos = freePos;
    freePos = xRight;
    brk = int(freePos-oldFreePos);
    timeDelta = int(brk/ticksPerBar)+1;
    if (timeDelta>barnum+1) { timeDelta = barnum+1; }
    if (brk>2) {
      brk = brk%ticksPerBar;
      xb = xoffset+5+int(time2*barlen*oldFreePos/(1536*time1))-barlen*xmOffset;
      // Pausen zwischen letzter Note und Taktstrich
      if (brk>2) { drawBreak(brk,xb-5,yoffset+2,N,barlen,&score); }
      for (int i=1; i<timeDelta; i++) {
	xb = xoffset+5+int(time2*barlen*(freePos-i*ticksPerBar)/(1536*time1))-barlen*xmOffset+barlen/2;
	drawBreak(ticksPerBar,xb,yoffset+2,N,barlen,&score);
      }
    }
    
  }

  
  // SELECTIONS:
  // -----------

  if (grabX1!=0 && abs(grabX1-grabX2)>5) { // draw grab rect
    score.drawRect(grabX1,16+YTOP+selSystem*100,grabX2-grabX1,80);
  }

  score.setPen(red);
  score.drawRect(8,YTOP+selSystem*100+38,4,29);

  score.end();

  //  if (part!=0) { part->print(); } else { cout << "no part !!" << endl; }

  //  sreal.begin(this);
  //  sreal.drawPixmap( myrect.topLeft(), pix );
  bitBlt( this, 0, 0, &pix );
  //sreal.end();

}



void QtScore::drawFlags( QPainter * score )
{
 flagPen = score->pen();
  // QPen* pen = &penx;
  if (xFlag[0]>0) {
    yFlag1 = yFlag1/nnFlag1;
    if (yFlag1>16) {
      yFlag1 = yFlag1Min-19;
      for (i=0;i<nnFlag1;i++) {
	flagPen.setWidth(0); score->setPen(flagPen);
	score->drawLine(QPoint(xFlag[i]+7,yFlagMax[i]),QPoint(xFlag[i]+7,yFlag1));
	//# anstelle von j=0, vielleicht j=$nFlag1 ?
	//flagPen.setWidth(3); score->setPen(flagPen); // back in for different lengths...
	//for (j=int(nFlag1);j<int(nFlag[i]);j++) {
	//  score->drawLine(QPoint(xFlag[i]+7,yFlag1+j*5),QPoint(xFlag[i]+13,yFlag1+j*5));
        //}
      }
      nnFlag1--;
      xFlag[nnFlag1]++;
      if (nnFlag1>0) {
	flagPen.setWidth(3); score->setPen(flagPen);
	for (i=0;i<int(nFlag1+0.9);i++) {
	  score->drawLine(QPoint(xFlag[0]+7,yFlag1+i*5),QPoint(xFlag[nnFlag1]+7,yFlag1+i*5));
	}
      } else {
	//cout << "nFlag1: " << int(nFlag1) << endl;
	for (i=0;i<int(nFlag1+0.9);i++) {
	  score->drawPixmap(xFlag[0]+9-2,yFlag1+i*5,imgFlag);
	}
      }
    } else {
      yFlag1 = yFlag1Max+19;
      for (i=0;i<nnFlag1;i++) {
	flagPen.setWidth(0); score->setPen(flagPen);
	score->drawLine(QPoint(xFlag[i]-1,yFlagMin[i]),QPoint(xFlag[i]-1,yFlag1));
	//flagPen.setWidth(3); score->setPen(flagPen); // back in for different lengths...
	//for (j=int(nFlag1);j<int(nFlag[i]);j++) {
	//  score->drawLine(QPoint(xFlag[i]-1,yFlag1+j*5),QPoint(xFlag[i]+5,yFlag1+j*5));
	//}
      }
      nnFlag1--;
      xFlag[nnFlag1]++;
      if (nnFlag1>0) {
	flagPen.setWidth(3); score->setPen(flagPen);
	for (i=0;i<int(nFlag1+0.9);i++) {
	  score->drawLine(QPoint(xFlag[0]-1,yFlag1-i*5),QPoint(xFlag[nnFlag1]-1,yFlag1-i*5));
	}
      } else {
	for (i=0;i<int(nFlag1+0.9);i++) {
	  score->drawPixmap(xFlag[0]+2-4,yFlag1-13+i*5,imgFlag1); // +2-4 war +2-3
	}
      }
    }
    xFlag[0] = 0;
    nnFlag1 = 0;
  
    flagPen.setWidth(0); score->setPen(flagPen);
  }
}


void QtScore::drawBreak( int l, int xx, int yy, int n, int barlen, QPainter * score )
{
  drawFlags(score);
  triX0 = 0;
  for (k=0;k<5 && l>0;k++) {
    xBrk[k] = 1.000000001*log(l/3)/log(2); // Seltsam, aber notwendig !!!!!
    l -= 3*int(pow(2,int(xBrk[k])));
    llBrk[k] = l;
  }
  xx += 2; // war 6 ??
  yy += 39;

  for (k--;k>-1;k--) {
    bb = int(xBrk[k]);
    if (bb>3 && bb<10 && xx>52) score->drawPixmap(xx,yy,arrBreak[bb]);
    if (k>0) xx += int(barlen*llBrk[k-1]/1800);
  }
}


int QtScore::draw(int xLeft, int xRight, QPainter * score)
{
  posCoef = 1.0*time2/(1536*time1);
  oldTimeBar = -1;
  freePos = 0;
  n = 0;
  scrClef = clef;
  for (i=0;i<7;i++) scrSigns[i]=allSigns[scrKey+7][i];

  yyOld = 0; xxOld = 0; xxCol = 0;
  yFlag1 = 0;
  nFlag1 = 0;
  nnFlag1 = 0;
  xFlag[0] = 0;
  yFlagMax[0] = 0; 
  yFlagMin[0] = 0;
  triX0 = -1;

  xoffset = 60+6*abs(scrKey);
  barlen = (scorelength-xoffset)/barnum;
  
  KbNote* note = part->gFirst();

  while (note!=0 && note->gPos()+deltaOff[N]<xLeft) note = note->gNext();
  while (note!=0 && note->gPos()+deltaOff[N]<xRight) {
    freq = note->gFreq();
    pos  = note->gPos()+deltaOff[N]; // falls mehr als ein Track gezeigt werden, die gegeneinander verschoben sind...

    len  = note->gLen();
    enh  = note->gEnh();
    next = note->gNext();
    if (next!=0) { deltapos = next->gPos()+deltaOff[N]-pos;} else { deltapos = 1; }
    
    step = freq%12;
    yy  = invFreq[freq];
    sg  = sign[freq];
    if (enh!=0) { yy += enhF[enh+2][step]; sg = enhS[enh+2][step]; }

    xx  = xoffset+2+int(barlen*(pos*posCoef-xmOffset));

    // makeTicksBeatBar(time1,time2,pos);
    main->BBT(pos,time1,time2);

    // BREAK Kram:

    brk = 0;
    timeDelta = main->gBar()-oldTimeBar;
    if (timeDelta>0) {
      drawFlags(score);
      for (i=0;i<7;i++) scrSigns[i]=allSigns[scrKey+7][i];
      oldTimeBar = main->gBar();
      oldFreePos = freePos;
      freePos =(main->gBar()-1)*ticksPerBar;
      brk = freePos-oldFreePos;
      if (brk>2) {
	brk = brk%ticksPerBar;
	xb = xoffset+5+int(barlen*(posCoef*oldFreePos-xmOffset));
	// fuer die Pausen zwischen der letzten Note im Takt bis zum Taktstrich (es sei denn, es kommt keine weitere Note mehr)
	if (brk>2) { drawBreak(brk,xb-5,yoffset+2,N,barlen,score); }
	for (i=1;i<timeDelta;i++) {
	  xb = xoffset+5+int(barlen*(posCoef*(freePos-i*ticksPerBar)-xmOffset)+barlen/2);
	  drawBreak(ticksPerBar,xb,yoffset+2,N,barlen,score);
	}
      }
    }
    brk = pos-freePos;
    freePos = pos+len;
    
    //# Pause:
    if (brk>2) { drawBreak(brk,xx-barlen*brk/(ticksPerBar),yoffset+2,N,barlen,score); }
  
    xx += 5;

    sgMem = scrSigns[yy%7]; // Vorzeichen
    scrSigns[yy%7] = sg;
    if (sgMem == sg) { sg = 0; } else { if (sg==0) { sg = 3; } }
    if (scrClef!=0) yy += yClef[scrClef]; // change yy when different clef
    if (sg!=0) { score->drawPixmap(xx-11,yy*3+yoffset-10,imgSign[sg+2]); } // draw Vorzeichen DOIT, position right ?!

    // cout << "yyOld: " << yyOld << ", yy: " << yy << ", xxOld: " << xxOld << ", xx: " << xx << endl;
    if (xxOld==xx) { if (abs(yyOld-yy)<2) { xxCol = 1-xxCol; xxShft = 8;} else { xxCol = 0; } }
    else { xxCol = 0; xxShft = 0; } // takes care of nearby notes 
    yyOld = yy; xxOld = xx;

    if (len>767) { img = imgNote[0]; } else { img = imgNote[1]; } // choose notebody (empty or filled)
    for (i=yy/2; i<6; i++) { score->drawLine(QPoint(xx-3,i*6+yoffset+5),QPoint(xx+9,i*6+yoffset+5)); } // draw Hilfslinien oben
    for (i=(yy-1)/2; i>10; i--) { score->drawLine(QPoint(xx-3,i*6+yoffset+5),QPoint(xx+9,i*6+yoffset+5)); } // ... unten
    if (N==selSystem)
      if (selNote==note || (selX1!=-1 && selX1 <= pos+leftPos && pos+leftPos <= selX2)) score->setPen(red); // selected Note red !
    score->drawPixmap(xx+xxCol*8,yy*3+yoffset-1,img); // draw notebody
    if (yy<=16) xx += xxShft;
    if (N==selSystem)
      if (selNote==note || (selX1!=-1 && selX1 <= pos+leftPos && pos+leftPos <= selX2)) score->setPen(black);


    if (yy<akkordmin) akkordmin = yy;
    if (yy>akkordmax) akkordmax = yy;
    if (len>akkordlen) akkordlen = len;
    dot = DOT(akkordlen);


    if (deltapos!=0) {       // if following note is not at the same (time-) position...
      if (akkordlen<1536) { // if the length of the note/chord is less than 1536 (was ticksPerBar, rsp. a bar, but wrong !!)...
	if (akkordlen==512 || akkordlen==256 || akkordlen==128 || akkordlen==64 || akkordlen==32 || akkordlen==16) { // triole
	  if (triX0!=-1) {
	    triMem += akkordlen;
	    if (akkordmax > triYmax) triYmax = akkordmax;
	    if (akkordmin < triYmin) triYmin = akkordmin;
	    if (triMem==1536 || triMem ==768 || triMem==384 || triMem==192 || triMem==96 || triMem==48) { // triolen zuende, 3 malen
	      triDX = (xx+triX0)/2;
	      if (akkordmax>16) score->drawText(triDX+3,3*triYmin-25+yoffset,"3"); // haelse nach oben
	      else score->drawText(triDX-3,3*triYmax+35+yoffset,"3"); // haelse nach unten
	      triX0 = -1;
	    }
	  } else { triX0 = xx; triYmin = akkordmin; triYmax = akkordmax; triMem = akkordlen; drawFlags(score); }
	} else { triX0 = -1; }
	if (abs(akkordmaxOld-akkordmax)>7) {
	  drawFlags(score);
	}
	akkordmaxOld = akkordmax;                  // memory: If diff in y is too large (>7), draw ! (s.a.)
	cl =  10-log(akkordlen/3)/log(2)-3;        // cl>0, if flags occur: 1 = 1/8, 2 = 1/16, 3 = 1/32, etc
	if (cl!=nFlag1) { drawFlags(score); }      // nFlag1 is the former cl: If difference: draw!
	if (cl>0) {                                // if flags occur...
	  if (xFlag[0]==0) {                       // xFlag is where the first(left most) flag occurs
	    xFlag[0]  = xx;                        // remember first x-pos
	    yFlag1Min = 3*akkordmin+2+yoffset;     // top y-pos of chord so far
	    yFlag1Max = 3*akkordmax+2+yoffset;     // bottom y-pos of chord so far
	    yFlagMax[0] = yFlag1Max;               // will be remembered
	    yFlagMin[0] = yFlag1Min;               // dito
	    nnFlag1   = 1;                         // nnFlag1 points to the next free space in the array
	    nFlag1    = cl;                        // number of flags
	    nFlag[0]  = cl;                        // will be remembered
	    yFlag1    = (akkordmax+akkordmin)/2;   // y center of chord
	  } else { 
	    xFlag[nnFlag1] = xx;                       // remember current x-pos
	    yyyMin    = 3*akkordmin+2+yoffset;         // top y-pos of chord so far
	    yyyMax    = 3*akkordmax+2+yoffset;         // bottom y-pos of chord so far
	    if (yFlag1Min>yyyMin) yFlag1Min = yyyMin;  // yFlag1Min holds the y minimum
	    if (yFlag1Max<yyyMax) yFlag1Max = yyyMax;  // yFlag1Max holds the y maximum
	    yFlagMax[nnFlag1] = yyyMax;                // will be remembered
	    yFlagMin[nnFlag1] = yyyMin;
	    nFlag[nnFlag1]    = cl;
	    if (cl<nFlag1) nFlag1 = cl;                // if difference, nFlag1 is maximum length
	    nnFlag1++;
	    yFlag1 += (akkordmax+akkordmin)/2;         // add center to yFlag1 in order to avarage later on
	  }
	} else {
	  if (akkordmax>16) {
	    flag = 3*akkordmin-19;
	    score->drawLine(QPoint(xx+7,flag+yoffset),QPoint(xx+7,3*akkordmax+1+yoffset)); // draw line to the right, up
	  } else {
	    flag = 3*akkordmax+19;
	    score->drawLine(QPoint(xx-1,flag+yoffset),QPoint(xx-1,3*akkordmin+1+yoffset)); // draw line to the left, down
	  }
	}
	if ((cl<1)||(nnFlag1>maxNnFlags-1)) { drawFlags(score); }
	
      } else {
	// # akkordlen>1536 !!
      }
	
      akkordmin = 80;
      akkordmax = 0;
      akkordlen = 0 ;
    }
   
    for (i=0;i<dot;i++) {
      score->drawText(xx+10+5*i,yy*3+yoffset,".");
    }
    
    
    note=note->gNext();

    if (allParts==TRUE && note==0 && part->gNext()!=0) { // to the following part ;-)
      drawFlags(score);
      part = part->gNext();
      note = part->gFirst();
      scrKey = part->gKey();
      clef = part->gClef();
      time1 = part->gTime1();
      time2 = part->gTime2();
      deltaOff[N] = (part->gFrom()-leftBar)*1536*part->gTime1()/part->gTime2();
      // cout << "hey: " << note->gPos() << ", " << deltaOff[N] << ", " << xRight << endl;
    }
    
  }
 
  return freePos;
}


int QtScore::DOT( int l ) {

  x0 = int(1.000000001 * log(l/3)/log(2)); l = l-3*int(pow(2,x0));
  if (l<3) l = 3;
  x1 = int(1.000000001 * log(l/3)/log(2)); l = l-3*int(pow(2,x1));
  if (l<3) l = 3;
  x2 = int(1.000000001 * log(l/3)/log(2)); l = l-3*int(pow(2,x2));
  return (x0-x1==1)+(x1-x2==1);

}


// *****************************************************************************
//
// SLOTS
// =====
//


void QtScore::mousePressEvent ( QMouseEvent * mouse ) {
  QtEditor::mousePressEvent(mouse);


}


void QtScore::mouseMoveEvent  ( QMouseEvent * mouse ) {
  QtEditor::mouseMoveEvent(mouse);

  buttonbar->setPos(main->gBar(),main->gBeat(),main->gTick());
  showFreq();
  
  // DOIT: setCursor(QCursor(2));
}


void QtScore::mouseReleaseEvent ( QMouseEvent * mouse ) {
  QtEditor::mouseReleaseEvent(mouse);

  int x = mouse->x();
  
  if (createNote==TRUE) { // Note erzeugen

    int yOff = mouse->y()-YTOP;
    int ySys = (yOff % 100);
    int system = (yOff-ySys)/100;

    // cout << "okt: " << system << endl;
    selSystem = system;
    getPartInfo();

    int yy = ySys/3;
    int myEnh = 0;

    if (yy>=0 && yy<=37 && selSystem<parts) {
      getPartInfo();
      scrKey = part->gKey();
      clef = part->gClef();

      xoffset  = 60+6*abs(scrKey);
      int xofftime = xoffset-10;
      
      double barlen = (scorelength-xoffset)/barnum;
      double deltax = barlen*time2*snapValue/(1536.0*time1); // snap was ticksOfLen(curlen)
      
      int xx = int(deltax*(1.0*(x-xoffset)/deltax))+xoffset+5;
      if (x<=20) { getPartInfo(); repaint( FALSE ); }
      if (x>20 && x<=xoffset) {
	// cout << "sel props" << endl;
	
	getPartInfo();
	QtChooser * chooser = new QtChooser( part,this );
	chooser->show();
      }
      if (x>xoffset) {
	if (clef!=0) yy -= yClef[clef];
	int freq = freqTab[yy];
	if (shftFlag) freq++;
	if (ctrlFlag) freq--;
	int llen = ticksOfLen(lenValue);

	pos = timeOfMouse(x);
	// check, if click is over a note that exists...
	if (mouse->button()==LeftButton) {
	  myEnh = enhValue;
	  if (shftFlag && myEnh<2) myEnh++; // if SHIFT is pressed, increase enh-mode by one only for this note to create...
	  if (ctrlFlag && myEnh>-2) myEnh--;
	  
	  cout << "score: " << freq << ", " << velocValue << ", " << llen << ", " << pos-deltaOff[selSystem] << ", " << myEnh << endl;
	  
	  part->addNote(new KbNote(freq,velocValue,llen,pos-deltaOff[selSystem]-leftPos,myEnh));
	  grabX1=0;
	  repaint( FALSE );
	  main->hit(part->gTrack()->gOutput(),part->gTrack()->gChannel(),freq,velocValue);
	  oldfreq = freq;
	}
	if (mouse->button()==MidButton) {
	  
	  KbNote * n;
	  for (n=part->gFirst(); n!=0 && (n->gPos()+deltaOff[selSystem]+leftPos<pos || n->gFreq()!=freq); n=n->gNext()) {}
	  selNote = n;
	  if (selNote!=0) showNoteInfo();
	  else showNoteInfoOff();
	  repaint( FALSE );
	}
	if (mouse->button()==RightButton) {
	  KbNote * n;
	  for (n=part->gFirst(); n!=0 && (n->gPos()+deltaOff[selSystem]+leftPos<pos || n->gFreq()!=freq); n=n->gNext()) {}
	  if (n!=0) {
	    part->deleteNote(n);
	    selNote = 0;
	    showNoteInfoOff();
	    repaint( FALSE );
	  }
	}
      }
    }
  }
}

void QtScore::showFreq() {
  // y-pos
  // int yy = (mouseY-yoffset)/3;

  yOff = mouseY-YTOP;
  yy = (yOff % 100);
  system = (yOff-yy)/100;
  
  if (system<parts) { 
    if (partList[system]->gClef()!=0) yy -= 3*yClef[partList[system]->gClef()];
    yy = yy/3;
    if (yy>=0 && yy<=37) {
      
      char ff = noteTab[yy];
      buttonbar->setFreq(ff,(int)6-(yy+4)/7,shftFlag,ctrlFlag);
    }
  }
}


void QtScore::keyPressEvent ( QKeyEvent * key ) {
  QtEditor::keyPressEvent(key);

}


void QtScore::keyReleaseEvent ( QKeyEvent * key ) {
  QtEditor::keyReleaseEvent(key);

}




#endif
