#ifndef _QTSCORE_H_
#define _QTSCORE_H_

#include "qtEditor.h"
#include "qtScoreButtons.h"

class KbNote;
class QtChooser;
/**
 * This is the qt implementation of the score editor.
 * @author Jan Wuerthner
 * @version 0.95
 */ 
class QtScore : public QtEditor
{
  friend QtChooser;

  Q_OBJECT
 private:
  QPixmap imgClef[15];
  QPixmap arrBreak[10];
  QPixmap imgNote[2];
  QPixmap imgSign[6];
  QPixmap imgFlat;
  QPixmap imgSharp;
  QPixmap imgFlag;
  QPixmap imgFlag1;

  Buttonbar * buttonbar;

  int enhValue;
  int yytext;
  bool showIN;
  bool showTN;
  int N;
  int scrKey;
  int scrSigns[8];
  int clef;
  int nKey;
  int xofftime;
  char t1[5];
  char t2[5];
  char t3[5];
  int y;
  int freePos;
  int oldFreePos;
  int ticksPerBar;
  int brk;
  int timeDelta;
  int xb;
  int system;
  int yOff;
  int ySys;

  int xLeft; // long int??
  int xRight; // long int??

  double posCoef;
  int oldTimeBar;
  int n;
  int scrClef;
  int i;
  int j;
  int k;
  int yyOld;
  int xxOld;
  int xxCol;
  int yFlag1;
  double nFlag[24];
  double nFlag1;
  int nnFlag1;
  int xFlag[24];
  int yFlagMax[24];
  int yFlag1Max;
  int yFlagMin[24];
  int yFlag1Min;
  int yyyMin;
  int yyyMax;
  int flag;
  int maxNnFlags;
  int triX0;
  int scorelength;
  int freq;
  int oldfreq;
  int pos;
  int len;
  int enh;
  KbNote * next;
  double deltapos;
  int step;
  int yy;
  int sg;
  int xx;
  int sgMem;
  int xxShft;
  QPixmap img;
  int akkordmin;
  int akkordmax;
  int akkordmaxOld;
  int akkordlen;
  int dot;
  int triMem;
  int triYmax;
  int triYmin;
  int triDX;
  double cl;
 
  int x0; int x1; int x2;
  QPen flagPen;

  double xBrk[5];
  double llBrk[5];
  int bb;
  // int x0; int x1; int x2;

  void drawFlags(QPainter*);
  void drawBreak(int,int,int,int,int,QPainter*);
  int draw(int,int,QPainter*);
  int DOT(int);
  virtual void showFreq();

 public:
  QtScore(KbPart * kbpart, bool all=false);
  int gEnhValue();
  void sEnhValue(int e);

  virtual void addOptions();
  virtual void settings();
  virtual void paintEvent( QPaintEvent * );

 public slots:
  virtual void optionsMenu(int);
  virtual void mousePressEvent ( QMouseEvent * );
  virtual void mouseMoveEvent  ( QMouseEvent * );
  virtual void mouseReleaseEvent ( QMouseEvent * );
  virtual void keyPressEvent ( QKeyEvent * );
  virtual void keyReleaseEvent ( QKeyEvent * );
 /**
  * resize event
  */
 virtual void resizeEvent( QResizeEvent * );
};

#endif
